using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Xml;

namespace Glow
{
	/// <summary>
	/// Zusammenfassung für Form1.
	/// </summary>
	public class TilesetForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.PictureBox pictureBox1;
		XmlDocument cfg = new XmlDocument();
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.ListBox listBox2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.StatusBar statusBar1;

		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TilesetForm()
		{
			//
			// Erforderlich für die Windows Form-Designerunterstützung
			//
			InitializeComponent();
			textBox1.Text = System.IO.Directory.GetCurrentDirectory();
			FillListbox();
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode für die Designerunterstützung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.panel2 = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.statusBar1);
			this.panel1.Controls.Add(this.button4);
			this.panel1.Controls.Add(this.button5);
			this.panel1.Controls.Add(this.buttonSave);
			this.panel1.Controls.Add(this.button3);
			this.panel1.Controls.Add(this.button1);
			this.panel1.Controls.Add(this.listBox2);
			this.panel1.Controls.Add(this.radioButton2);
			this.panel1.Controls.Add(this.button2);
			this.panel1.Controls.Add(this.textBox1);
			this.panel1.Controls.Add(this.listBox1);
			this.panel1.Controls.Add(this.radioButton1);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(280, 566);
			this.panel1.TabIndex = 0;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 544);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(280, 22);
			this.statusBar1.SizingGrip = false;
			this.statusBar1.TabIndex = 13;
			// 
			// button4
			// 
			this.button4.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button4.Location = new System.Drawing.Point(8, 472);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(120, 23);
			this.button4.TabIndex = 10;
			this.button4.Text = "Runter [&A]";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button5
			// 
			this.button5.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button5.Location = new System.Drawing.Point(8, 448);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(120, 23);
			this.button5.TabIndex = 9;
			this.button5.Text = "Hoch [&Q]";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.buttonSave.Location = new System.Drawing.Point(8, 504);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(248, 23);
			this.buttonSave.TabIndex = 8;
			this.buttonSave.Text = "Speichern...";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// button3
			// 
			this.button3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button3.Location = new System.Drawing.Point(136, 472);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(120, 23);
			this.button3.TabIndex = 7;
			this.button3.Text = "Runter [&S]";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.button1.Location = new System.Drawing.Point(136, 448);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 23);
			this.button1.TabIndex = 6;
			this.button1.Text = "Hoch [&W]";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// listBox2
			// 
			this.listBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.listBox2.Location = new System.Drawing.Point(136, 104);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(120, 342);
			this.listBox2.TabIndex = 5;
			this.listBox2.SelectedIndexChanged += new System.EventHandler(this.listBox2_SelectedIndexChanged);
			// 
			// radioButton2
			// 
			this.radioButton2.Checked = true;
			this.radioButton2.Location = new System.Drawing.Point(8, 40);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(248, 16);
			this.radioButton2.TabIndex = 3;
			this.radioButton2.TabStop = true;
			this.radioButton2.Text = "Editor-Ansicht";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.doRefresh);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(136, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Ordner wählen...";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(8, 8);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(120, 20);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "." + Path.DirectorySeparatorChar;
			// 
			// listBox1
			// 
			this.listBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.listBox1.Location = new System.Drawing.Point(8, 104);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(120, 342);
			this.listBox1.TabIndex = 4;
			this.listBox1.SelectedIndexChanged += new System.EventHandler(this.listBox1_SelectedIndexChanged);
			// 
			// radioButton1
			// 
			this.radioButton1.Location = new System.Drawing.Point(8, 56);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(248, 16);
			this.radioButton1.TabIndex = 2;
			this.radioButton1.Text = "Speicherbelegung";
			this.radioButton1.CheckedChanged += new System.EventHandler(this.doRefresh);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 88);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(120, 23);
			this.label1.TabIndex = 11;
			this.label1.Text = "Tile-Set:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(136, 88);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(120, 23);
			this.label2.TabIndex = 12;
			this.label2.Text = "Tiles:";
			// 
			// panel2
			// 
			this.panel2.AutoScroll = true;
			this.panel2.Controls.Add(this.pictureBox1);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(280, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(352, 566);
			this.panel2.TabIndex = 1;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(256, 256);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			// 
			// folderBrowserDialog1
			// 
			this.folderBrowserDialog1.Description = "Glow-Stammverzeichnis wählen";
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.DefaultExt = "xml";
			this.saveFileDialog1.Filter = "Tile-Sets (T*.xml)|T*.xml";
			this.saveFileDialog1.Title = "Tile-Sets speichern";
			// 
			// TilesetForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 566);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Name = "TilesetForm";
			this.Text = "Glow Tileset-Tool von Thiemo Mättig";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt für die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TilesetForm());
		}

		private void FillListbox()
		{
			string filename = textBox1.Text;
			if (!filename.EndsWith(Path.DirectorySeparatorChar.ToString()))
				filename += Path.DirectorySeparatorChar;
			filename += "Config" + Path.DirectorySeparatorChar + "TileSets.xml";
			if (!File.Exists(filename))
			{
				MessageBox.Show("Datei " + filename + " nicht gefunden.");
				return;
			}
			listBox1.Items.Clear();
			cfg.Load(filename);
			foreach (XmlNode node in cfg.SelectNodes("*/TileSet/@*[name()='id' or name()='name']"))
			{
				listBox1.Items.Add(node.Value);
			}
			if (listBox1.Items.Count > 0)
				listBox1.SelectedIndex = 0;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			folderBrowserDialog1.SelectedPath = textBox1.Text;
			if (folderBrowserDialog1.ShowDialog(this) != DialogResult.OK)
				return;
			textBox1.Text = folderBrowserDialog1.SelectedPath;
			FillListbox();
		}

		private void doRefresh(object sender, System.EventArgs e)
		{
			pictureBox1.Refresh();
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if (listBox1.SelectedIndex < 0)
				return;
			string name = listBox1.SelectedItem.ToString();
			string tileName = "";
			if (listBox2.SelectedIndex >= 0)
				tileName = listBox2.SelectedItem.ToString();
			XmlNode cfgSet = cfg.SelectSingleNode("*/TileSet[@id='" + name + "' or @name='" + name + "']");
			int memoryWidth = Convert.ToInt32(cfgSet.Attributes["width"].Value);
			int memoryHeight = Convert.ToInt32(cfgSet.Attributes["height"].Value);
			if ((memoryWidth & (memoryWidth - 1)) != 0 || (memoryHeight & (memoryHeight - 1)) != 0)
			{
				MessageBox.Show("Größe ist nicht Power-of-Two.");
			}
			int width = memoryWidth, height = memoryHeight;
			if (radioButton2.Checked)
			{
				width  =  5 * 32;
				height = 80 * 32; //identisch zum Editor
			}
			pictureBox1.Width = width;
			pictureBox1.Height = height;
			Graphics g = e.Graphics;
			g.Clear(Color.Gray);
			Brush[] brush = new Brush[2];
			brush[0] = new SolidBrush(Color.FromArgb(4, Color.Black));
			brush[1] = new SolidBrush(Color.FromArgb(4, Color.White));
			for (int y = 0; y < height; y += 32)
			{
				for (int x = 0; x < width; x += 32)
				{
					g.FillRectangle(brush[((x + y) / 32) % 2], x, y, 32, 32);
				}
			}

			Pen boxPen = new Pen(Color.FromArgb(40, Color.Blue));
			Brush boxBrush = new SolidBrush(Color.FromArgb(40, Color.Blue));
			//boxPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;

			bool[,] usage = new bool[width / 32, height / 32];
			int area = 0;

			foreach (XmlNode node in cfgSet.ChildNodes)
			{
				if (node.NodeType != XmlNodeType.Element)
					continue;
				string filename = textBox1.Text
					+ Path.DirectorySeparatorChar + "Data" + Path.DirectorySeparatorChar + "Tiles" + Path.DirectorySeparatorChar
					+ node.Attributes["file"].Value;
				try
				{
					Bitmap bmp = new Bitmap(32, 32);
					try
					{
						bmp = new Bitmap(filename);
					}
					catch (ArgumentException ex)
					{
						Graphics g2 = Graphics.FromImage(bmp);
						g2.DrawLine(new Pen(Color.Red), 0, 0, bmp.Width - 1, bmp.Height - 1);
						g2.DrawLine(new Pen(Color.Red), 0, bmp.Height - 1, bmp.Width - 1, 0);
						g2.Dispose();
					}
					area += (bmp.Width / 32) * (bmp.Height / 32);

					int posX = -1, posY = -1;
					bool free = false;
					int searchWidth = (width - bmp.Width) / 32;
					int searchStep = 1;
					if (!radioButton2.Checked) //nicht Editor
					{
						searchStep = bmp.Width / 32;
					}
					int cmpWidth = bmp.Width / 32;
					if (radioButton2.Checked && searchWidth < 0)
					{
						searchWidth = 0;
						cmpWidth = Math.Min(cmpWidth, 5);
					}
					for (int y = 0; y <= (height - bmp.Height) / 32; y++)
					{
						for (int x = 0; x <= searchWidth; x += searchStep)
						{
							free = true;
							for (int y2 = 0; y2 < bmp.Height / 32; y2++)
							{
								for (int x2 = 0; x2 < cmpWidth; x2++)
								{
									if (usage[x + x2, y + y2])
									{
										free = false;
										break;
									}
								}
								if (!free)
									break;
							}
							if (free)
							{
								posX = x * 32;
								posY = y * 32;
								break;
							}
						}
						if (posX >= 0)
							break;
					}
					if (posX < 0 || posY < 0)
					{
						// MessageBox.Show("Nicht genug Platz im Set.");
						// return;
						g.FillRectangle(new SolidBrush(Color.FromArgb(127, 255, 0, 0)),
							0, 0, width, height);
						continue;
					}

					g.DrawImage(bmp, posX, posY,
						bmp.PhysicalDimension.Width, bmp.PhysicalDimension.Height);
					if ((node.Attributes["id"] != null && node.Attributes["id"].Value == tileName) || node.Name == tileName)
					{
						g.FillRectangle(boxBrush, posX, posY,
							bmp.PhysicalDimension.Width - 1, bmp.PhysicalDimension.Height - 1);
					}
					g.DrawRectangle(boxPen, posX, posY,
						bmp.PhysicalDimension.Width - 1, bmp.PhysicalDimension.Height - 1);

					// Als belegt markieren
					for (int x = 0; x < bmp.Width / 32; x++)
					{
						if (posX / 32 + x >= usage.GetLength(0))
							continue;
						for (int y = 0; y < bmp.Height / 32; y++)
						{
							usage[posX / 32 + x, posY / 32 + y] = true;
						}
					}
					bmp.Dispose();
				}
				catch (Exception ex)
				{
					// MessageBox.Show(ex.GetType().FullName);
					// MessageBox.Show("Datei " + filename + " nicht gefunden.");
				}
			}

			int setArea = ((memoryWidth / 32) * (memoryHeight / 32));
			double percent = 100.0 / setArea * area;
			if (percent <= 50.0)
			{
				g.FillRectangle(new SolidBrush(Color.FromArgb(127, 255, 0, 0)), 0, height / 2,
					width - 1, height / 2 - 1);
			}
			statusBar1.Text = "Belegt " + area + " Tiles (" +
				Math.Round(percent) + "%), " + (setArea - area) + " Tiles frei";
		}

		private void listBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (listBox1.SelectedIndex < 0)
				return;
			listBox2.Items.Clear();
			string xpath = "*/TileSet[@id='" + listBox1.SelectedItem.ToString() + "' or @name='" + listBox1.SelectedItem.ToString() + "']/*";
			foreach (XmlNode node in cfg.SelectNodes(xpath))
			{
				if (node.NodeType != XmlNodeType.Element)
				{
					node.ParentNode.RemoveChild(node);
					continue;
				}
				listBox2.Items.Add(node.Attributes["id"] != null ? node.Attributes["id"].Value : node.Name);
			}
			if (listBox2.Items.Count > 0)
				listBox2.SelectedIndex = 0;
			doRefresh(sender, e);
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index <= 0)
				return;
			listBox1.Items.Insert(index - 1, listBox1.Items[index]);
			listBox1.Items.RemoveAt(index + 1);
			listBox1.SelectedIndex = index - 1;

			string setName = listBox1.SelectedItem.ToString();
			XmlNode node = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "' or @name='" + setName + "']");
			while (node.PreviousSibling.NodeType != XmlNodeType.Element)
			{
				node.ParentNode.RemoveChild(node.PreviousSibling);
			}
			XmlNode node2 = node.PreviousSibling;
			node.ParentNode.RemoveChild(node);
			node2.ParentNode.InsertBefore(node, node2);

			doRefresh(sender, e);
			listBox1.Select();
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			int index = listBox1.SelectedIndex;
			if (index >= listBox1.Items.Count - 1)
				return;
			listBox1.Items.Insert(index + 2, listBox1.Items[index]);
			listBox1.Items.RemoveAt(index);
			listBox1.SelectedIndex = index + 1;

			string setName = listBox1.SelectedItem.ToString();
			XmlNode node = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "' or @name='" + setName + "']");
			while (node.NextSibling.NodeType != XmlNodeType.Element)
			{
				node.ParentNode.RemoveChild(node.NextSibling);
			}
			XmlNode node2 = node.NextSibling;
			node.ParentNode.RemoveChild(node);
			node2.ParentNode.InsertAfter(node, node2);

			doRefresh(sender, e);
			listBox1.Select();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			int index = listBox2.SelectedIndex;
			if (index <= 0)
				return;
			listBox2.Items.Insert(index - 1, listBox2.Items[index]);
			listBox2.Items.RemoveAt(index + 1);
			listBox2.SelectedIndex = index - 1;

			string setName = listBox1.SelectedItem.ToString();
			string tileName = listBox2.SelectedItem.ToString();
			XmlNode tile = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "' or @name='" + setName + "']/" + (Char.IsDigit(tileName, 0) ? "TileGroup[@id='" + tileName + "']" : tileName));
			XmlNode tile2 = tile.PreviousSibling;
			tile.ParentNode.RemoveChild(tile);
			tile2.ParentNode.InsertBefore(tile, tile2);

			doRefresh(sender, e);
			listBox2.Select();
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			int index = listBox2.SelectedIndex;
			if (index >= listBox2.Items.Count - 1)
				return;
			listBox2.Items.Insert(index + 2, listBox2.Items[index]);
				listBox2.Items.RemoveAt(index);
			listBox2.SelectedIndex = index + 1;

			string setName = listBox1.SelectedItem.ToString();
			string tileName = listBox2.SelectedItem.ToString();
			XmlNode tile = cfg.SelectSingleNode("*/TileSet[@id='" + setName + "' or @name='" + setName + "']/" + (Char.IsDigit(tileName, 0) ? "TileGroup[@id='" + tileName + "']" : tileName));
            XmlNode tile2 = tile.NextSibling;
			tile.ParentNode.RemoveChild(tile);
			tile2.ParentNode.InsertAfter(tile, tile2);
			
			doRefresh(sender, e);
			listBox2.Select();
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			string dir = textBox1.Text;
			if (! dir.EndsWith(Path.DirectorySeparatorChar.ToString()))
				dir += Path.DirectorySeparatorChar;
			dir += "Config";
			saveFileDialog1.InitialDirectory = dir;
			if (saveFileDialog1.ShowDialog() != DialogResult.OK)
				return;

			XmlTextWriter writer = new XmlTextWriter(saveFileDialog1.FileName, null);
			writer.Formatting = Formatting.Indented;
			writer.Indentation = 3;
			cfg.Save(writer);
			writer.Close();
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			if (listBox1.SelectedIndex < 0)
				return;
			string name = listBox1.SelectedItem.ToString();
			XmlNode cfgSet = cfg.SelectSingleNode("*/TileSet[@id='" + name + "' or @name='" + name + "']");
		}

		private void listBox2_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			doRefresh(sender, e);
		}
	}
}