#!/bin/sh

# To run the executable, you need the Mono runtime installed:
#     sudo apt-get install mono-runtime
# Try running the executable via Mono if it refuses to run on it's own:
#     mono Executable.exe
#
# To compile the executable yourself, you need the Mono compiler installed:
#     sudo apt-get install mono-complete

NAME=Tileset-Tool
SRC="Sources (C# with .NET 1.1)"
RES="$SRC/Glow.TilesetForm.resources"
EXE="${NAME}.Mono.exe"

resgen "$SRC/TilesetForm.resx" "$RES"
mcs "$SRC/TilesetForm.cs" -r:System.Data -r:System.Drawing -r:System.Windows.Forms -res:"$RES" -out:"$EXE"
rm "$RES"
chmod a+x "$EXE"
